import { Injectable } from '@nestjs/common';
import { ConfigurationResponseDto } from './interface/dtos/configuration.response.dto';
import {
  ConfigurationIdentifier,
  ConfigurationValue,
} from '@mobicoop/configuration-module';
import { ConfigurationsManagerService } from './core/application/services/configurations-manager.service';

@Injectable()
export class ConfigurationMapper {
  constructor(
    private readonly configurationsManager: ConfigurationsManagerService,
  ) {}

  toResponse = (
    configurationIdentifier: ConfigurationIdentifier,
    configurationValue: ConfigurationValue,
  ): ConfigurationResponseDto => {
    const response = new ConfigurationResponseDto();
    response.domain = configurationIdentifier.domain;
    response.key = configurationIdentifier.key;
    response.value = configurationValue;
    response.type =
      this.configurationsManager.configurationType(configurationValue);
    return response;
  };
}
