import {
  ConfigurationDomain,
  NotFoundException,
} from '@mobicoop/configuration-module';
import { CONFIGURATION_REPOSITORY } from '@modules/configuration/configuration.di-tokens';
import { ConfigurationsManagerService } from '@modules/configuration/core/application/services/configurations-manager.service';
import { PopulateService } from '@modules/configuration/core/application/services/populate.service';
import { Test, TestingModule } from '@nestjs/testing';

const mockConfigurationRepository = {
  get: jest
    .fn()
    .mockImplementationOnce(() => 'someValue')
    .mockImplementationOnce(() => {
      throw new NotFoundException('Configuration not found');
    }),
  set: jest.fn(),
};

const mockConfigurationsManagerService = {
  list: jest.fn().mockImplementation(() => [
    {
      domain: ConfigurationDomain.CARPOOL,
      departureTimeMargin: 900,
      role: 'passenger',
      seatsProposed: 3,
      seatsRequested: 1,
      strictFrequency: false,
    },
    {
      domain: ConfigurationDomain.PAGINATION,
      perPage: 10,
    },
  ]),
};

describe('Populate Service', () => {
  let populateService: PopulateService;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      providers: [
        {
          provide: CONFIGURATION_REPOSITORY,
          useValue: mockConfigurationRepository,
        },
        {
          provide: ConfigurationsManagerService,
          useValue: mockConfigurationsManagerService,
        },
        PopulateService,
      ],
    }).compile();

    populateService = module.get<PopulateService>(PopulateService);
    populateService.onApplicationBootstrap();
  });

  it('should be defined', () => {
    expect(populateService).toBeDefined();
  });
});
